include "MyHomeLib.jsh"
include "hjconst.jsh"
include "MyHomeLib.jsm"

Globals
int giCurrentView,
int giCurrentKey

Script AlfavitRus ()
var
handle hand,
string s,
int x,
int y

JAWSCursor ()
FindString (GetAppMainWindow (GetCurrentWindow ()), "-", s_top, s_unrestricted)
let hand=GetCurrentWindow ()
SayChunk ()
let x=GetCursorCol ()
let y=GetCursorRow ()
PCCursor ()

InputBox ("   ", " ", s)
if s < ""  || s > "" || StringLength (s) !=1 then 
SayString (" ")
return
EndIf

JAWSCursor ()
MoveTo (x, y)
;SayChunk ()
if FindString (GetAppMainWindow (GetCurrentWindow ()), s, s_Next, s_unrestricted) then
LeftMouseButton ()
SayChunk ()
EndIf
;SayString (s)

PCCursor ()
EndScript

;  .
Script TotalArhifs ()
if GetWindowClass (GetParent (GetFocus ())) == "TImportProgressFormEx" then
if FindString (GetCurrentWindow (), " :", s_top, s_unrestricted) then
JAWSCursor ()
SayChunk ()
PCCursor ()
EndIf
EndIf
EndScript

Script AlfavitEnu ()
var
handle hand,
string s,
int x,
int y

JAWSCursor ()
FindString (GetAppMainWindow (GetCurrentWindow ()), "A-Z", s_top, s_unrestricted)
let hand=GetCurrentWindow ()
NextWord ()
NextWord ()
;SayChunk ()
let x=GetCursorCol ()
let y=GetCursorRow ()
PCCursor ()

InputBox (" A  Z", " ", s)
if s < "a"  || s > "z" || StringLength (s) !=1 then 
SayString (" ")
return
EndIf

JAWSCursor ()
MoveTo (x, y)
;SayChunk ()
if FindString (GetAppMainWindow (GetCurrentWindow ()), s, s_Next, s_unrestricted) then
LeftMouseButton ()
SayChunk ()
EndIf
;SayString (s)

PCCursor ()
EndScript
	
Script HotKeyHelp ()
SayString ("   ")
SayFormattedMessage (OT_USER_BUFFER, msgHelp) 
EndScript

Void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
	int PrevView,
string sClass

Pause ()
if FocusWindow == PrevWindow && !DialogActive() then
	return
EndIf

let sClass=GetWindowClass (FocusWindow )
if sClass == "TRzPageControl" then
let giCurrentView=tab
SayTab ()
elif sClass == "TRzEdit" then
let giCurrentView=edit
elif sClass == "TVirtualStringTree" && GetPriorWindow (FocusWindow) then
let giCurrentView=tray1
elif sClass == "TVirtualStringTree" && not GetPriorWindow (FocusWindow) then
let giCurrentView=tray2
if not GetWindowTextEx (FocusWindow , 1, 1) then
{Home}
EndIf
EndIf

FocusChangedEvent(FocusWindow, PrevWindow)
EndFunction

Void Function KeyPressedEvent (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
;SayInteger (nKey)
if nKey == 15 || nKey == 8388623 then
let giCurrentKey=nKey
EndIf
KeyPressedEvent (nKey, strKeyName, nIsBrailleKey, nIsScriptKey)
EndFunction

Script SayLine ()
var
handle hand,
int restrict,
string class

if IsPCCursor () && not UserBufferIsActive () then
let class=GetWindowClass (GetFocus ())
if class == "#32768" then
let giCurrentView=0
SayLine ()
return
EndIf

if class == "TMemo" then
let giCurrentView=0
SayString (GetWindowText (GetCurrentWindow (), 0))
return
EndIf

if giCurrentView== tab then
;SayString ("tab")
SpeechOff ()
return SayTab ()
elif giCurrentView== tray1 then
;SayString ("tray1")
			sayObjectActiveItem()
return
elif giCurrentView== tray2 then
;SayString ("tray2")
let hand=FindWindow (GetAppMainWindow (GetFocus ()), "TMHLInfoPanel", "")
if hand then
MoveToWindow (hand)
let restrict=GetRestriction ()
SetRestriction (3)
NextLine ()
SayLine ()
SetRestriction (restrict)
PCCursor ()
EndIf
return
EndIf
EndIf
SpeechOn ()
;TypeCurrentScriptKey ()
SayLine ()
EndScript

Script NextCharacter ()
if giCurrentView== tab && GetWindowClass (GetFocus ()) != "TfrmMain" && IsPCCursor () then

SpeechOff ()
NextCharacter ()
Pause ()
	SayTab ()
else
TypeCurrentScriptKey ()
EndIf
EndScript

Script PriorCharacter ()
if giCurrentView== tab && GetWindowClass (GetFocus ()) != "TfrmMain" && IsPCCursor () then
SpeechOff ()
PriorCharacter ()
Pause ()
SayTab ()
else
TypeCurrentScriptKey ()
EndIf
EndScript

String Function SayTab ()
var
string s
Pause ()
let s=StringSegment (GetWindowText (FindWindow (GetAppMainWindow (GetFocus ()), "TRzPageControl", ""), 1)," ",1)
SpeechOn ()
SayString (s)
EndFunction


Script Down ()
if giCurrentView==tray1 || giCurrentView==tray2 then
SpeechOff ()
NextLine ()
Pause ()
SpeechOn ()
PerformScript SayLine()
return
EndIf
TypeCurrentScriptKey ()
EndScript


Script Up ()

if giCurrentView==tray1 || giCurrentView==tray2 then
SpeechOff ()
PriorLine ()
Pause ()
SpeechOn ()
PerformScript SayLine()
return
EndIf
TypeCurrentScriptKey ()
EndScript

Script jarn ()
SayInfo (2,"")
EndScript


Script File ()
SayInfo (1,": ")
EndScript


Script avtor ()
SayInfo (0,": ")
EndScript

Script folder ()
SayInfo (3,"")
EndScript

Void Function SayInfo (int strok, string stroka)
var
handle hand,
int restrict,
string s

let hand=FindWindow (GetAppMainWindow (GetFocus ()), "TMHLInfoPanel", "")
if hand then
MoveToWindow (hand)
let restrict=GetRestriction ()
SetRestriction (3)
let s=GetChunk ()
if s == ":" then
SayString ("  ")
SetRestriction (restrict)
PCCursor ()
return
EndIf
While strok >0
NextLine ()
let strok=strok-1
EndWhile
SayString (stroka)
SayLine ()
SetRestriction (restrict)
PCCursor ()
EndIf
return
EndFunction

Script VkladkaVlevo ()
SpeechOff ()
{Control+Shift+Tab}
Pause ()
SayTab ()
EndScript

Script VkladkaVpravo ()
SpeechOff ()
{Control+Tab}
Pause ()
SayTab ()
EndScript

Script Izbrannoe ()
{Control+F}
SayString ("   :")
PerformScript jarn()
PerformScript avtor()
PerformScript File()

EndScript
